/*
 * LCD Waveform Generator
 * Created: 3/4/2024
 *  Author: moty22.co.uk
*/

#include <LiquidCrystal.h>
#include <SPI.h>

#define up A0  //UP switch
#define digit A1 //digit sel sw 
#define wave A2 //waveform sel sw
#define fsync 8 //CS

  unsigned char d[7], wf=0;
  unsigned char i=0, pos=4, j=0;
  
   // initialize the library with the numbers of the interface pins
  LiquidCrystal lcd(7, 6, 2, 3, 4, 5);

void setup() {
 
    lcd.begin(16, 2);   // set up the LCD's number of columns and rows:
    SPI.begin();

    pinMode(fsync, OUTPUT);
    pinMode(A0, INPUT_PULLUP);
    pinMode(A1, INPUT_PULLUP);
    pinMode(A2, INPUT_PULLUP);
    
    lcd.setCursor(7, 0); // top middle
    lcd.print("hi");
    delay(1000);
    lcd.setCursor(3,0);
    for(i=0;i<7;++i){
        if(i==3){d[3]=1;}else{d[i]=0;}
        lcd.print(d[i]);
    }

    setFreq();

}

void loop() {
    if(!digitalRead(wave)){
        j +=1;
        if(j>2){j=0;}
        if(j==0){wf=0; lcd.setCursor(11,0); lcd.print("SN");}    //sine
        if(j==1){wf=2; lcd.setCursor(11,0); lcd.print("TR");}    //triangle    
        if(j==2){wf=40; lcd.setCursor(11,0); lcd.print("SQ");}    //square 
        setFreq();
        delay(500);
    }
    if(!digitalRead(digit)){
        lcd.setCursor(pos+3, 1); lcd.print(" ");
        pos +=1;
        if(pos>6){pos=0;}
        lcd.setCursor(pos+3, 1); lcd.print("^");
        delay(500);
    }
    if(!digitalRead(up)){
        d[pos] +=1;
        if(d[pos]>9){d[pos]=0;}
        lcd.setCursor(pos+3, 0); lcd.print(d[pos]);
        setFreq();
        delay(500);
    }

}

void setFreq(){
    unsigned long reg;    //freq, 
    double Dreg;
    unsigned char b1, b2, b3, b4;
    
    reg = (d[6])+(unsigned long)(d[5])*10+(unsigned long)(d[4])*100+
            (unsigned long)(d[3])*1000+(unsigned long)(d[2])*10000+
            (unsigned long)(d[1])*100000+(unsigned long)(d[0])*1000000;

    Dreg=reg*10.7374;
    reg=(unsigned long)Dreg;
    b1 = reg & 255;
    b2 = (reg>>8) & 63;
    b3 = (reg>>14) & 255;
    b4 = (reg>>22) & 63;
    spi(0x20, wf); //write 28 bits
    spi(64 + b2, b1); //write LSB freq reg0
    spi(64 + b4, b3); //write MSB freq reg0
}

void spi(unsigned char b1, unsigned char b2){
  digitalWrite(fsync,LOW);
  SPI.beginTransaction(SPISettings(2000000, MSBFIRST, SPI_MODE2));
  SPI.transfer(b1);
  SPI.transfer(b2);
  SPI.endTransaction();
  digitalWrite(fsync,HIGH);
}
